#!/usr/bin/env python
#-*- coding:utf-8 -*


"""
	Manage the interface with cx_freeze
	
	G{importgraph}
"""


#	Pyxmaker
#	Copyright (C) 2013 GALODE A.
#
#	This file is part of Expymaker.
# 
#	Pyxmaker is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
# 
#	Pyxmaker is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with Pyxmaker.  If not, see <http://www.gnu.org/licenses/>


import os
import sys
import shutil
import subprocess




#=======================================================================#
#				classe gérant la connexion avec cx_freeze				#
#=======================================================================#
class CxfPyxmaker():
	"""
		Class whichinterface Pyxmaker and cx_freeze

		G{classtree}
	"""
	
	
	#===================================================#
	#              Fenetre Confirmation                 #
	#===================================================#	
	def __init__(self):
		None
		
		
		
		
	#===================================================#
	#       Procedure de creation de la structure		#
	#===================================================#	
	def p_struct_creation(self, dict_param):
		"""
			Allow to create the setup directory in the output repertory
			
			PARAMETERS
			==========
				dict_param
				----------
					A dictionnary with all needed parameters	
						
			RETURNS
			=======
				None
		"""
		src = dict_param["DIR_PJ"]
		dst = dict_param["PJ_PATH"]
		shutil.rmtree(dict_param["STRUCT_PATH"], True)
		shutil.copytree(src, dst)	
		
		
		
		
	#===================================================#
	#     Procedure de creation du script cx_freeze		#
	#===================================================#		
	def p_script_creation(self, dict_param):
		"""
			Allow to create the setup directory in the output repertory
			
			PARAMETERS
			==========
				dict_param
				----------
					A dictionnary with all needed parameters	
						
			RETURNS
			=======
				None
		"""
		path = os.path.join(dict_param["SCRIPTS_PATH"], "script_cxf.py")
		with open(path, 'r') as fichier:
			script = fichier.read()
		fichier.close()
		
		script = script.replace("$$INCLUDES$$", dict_param["CXF_INCLUDE"])
		script = script.replace("$$EXCLUDES$$", dict_param["CXF_EXCLUDE"])
		script = script.replace("$$PACKAGES$$", dict_param["CXF_PACKAGE"])
		script = script.replace("$$INCLUDE_FILES$$", dict_param["CXF_INCLUDE_FILE"])
		script = script.replace("$$NAME_EXEC$$",dict_param["EXECUTABLE"])
		script = script.replace("$$NAME$$",dict_param["NAME"])
		script = script.replace("$$VERSION$$",dict_param["VERSION"])
		script = script.replace("$$DESCRIPTION$$",dict_param["DESCRIPTION"])
		script = script.replace("$$AUTHOR$$",dict_param["AUTHOR"])
		script = script.replace("$$AUTHOR_MAIL$$",dict_param["AUTHOR_MAIL"])
		script = script.replace("$$MAINTAINER$$",dict_param["MAINTAINER"])
		script = script.replace("$$MAINTAINER_MAIL$$",dict_param["MAINTAINER_MAIL"])
		script = script.replace("$$WEBSITE$$",dict_param["WEBSITE"])
		script = script.replace("$$WINCONS$$",dict_param["WINCONS"])
		
		if dict_param["ICON_EXEC"] <> "":
			script = script.replace("$$ICON_EXEC$$",dict_param["ICON_EXEC"])
		else:
			script = script.replace("\n    icon = \"$$ICON_EXEC$$\",","")
			
		if dict_param["ICON"] <> "":
			script = script.replace("$$ICON$$",dict_param["ICON"])
		else:
			script = script.replace("\n    icon = \"$$ICON$$\",","")		
		
		path = os.path.join(dict_param["PJ_PATH"], "script.py")
		with open(path, "w") as fichier:
			fichier.write(script)
		fichier.close()
	
	
	
	
	#===================================================#
	#     	   Fonction générant l'executable			#
	#===================================================#		
	def f_exe_creation(self, dict_param):
		"""
			Allow to create the setup directory in the output repertory
			
			PARAMETERS
			==========
				dict_param
				----------
					A dictionnary with all needed parameters	
						
			RETURNS
			=======
				None
		"""
		cmd0 = dict_param["PJ_PATH"]
		cmd0 = r"%s"%(cmd0,)
		cmd1 = "python script.py build & exit\n"
		stdout_file = open(os.path.join(dict_param["STRUCT_PATH"],"cxf_log.log"), "w+")
		proc = subprocess.Popen(cmd1, shell=True, cwd=cmd0, stdout=stdout_file, stderr=subprocess.STDOUT)
		proc.communicate()
		stdout_file.seek(0)
		stdout = stdout_file.read()
		#cwd indique le chemin ou s'execute la commande
		proc.wait()
		#on attend la fin de l'execution de la commande
		
		with open(os.path.join(dict_param["STRUCT_PATH"],"cxf_log.log"), "r") as log:
			contenu = log.read().lower()
			if contenu.find("cannot") <> -1 or contenu.find("problem") <> -1 or \
				contenu.find("error") <> -1:
				return 2
			elif  contenu.count("warning") > 2:
				return 2
			else:
				return 0
		
		log.close()
		
		
	#===================================================#
	#      Procedure generant le zip du standalone      #
	#===================================================#		
	def p_zip_standalone(self, dict_param):
		"""
			Allow to generate the zip that contains the standalone version
			
			PARAMETERS
			==========
				dict_param
				----------
					A dictionnary with all needed parameters	
						
			RETURNS
			=======
				None
		"""
		path_dir = os.path.join(dict_param["PJ_PATH"],"build")
		print path_dir
		exe = os.listdir(path_dir)[0]
		print exe
		path_zip = os.path.join(dict_param["STRUCT_PATH"], dict_param["NAME"] + "_" + dict_param["VERSION"] + "_" + "standalone")
		print path_zip
		shutil.make_archive(path_zip, "zip", os.path.join(path_dir,exe))
		
		
		
		
	#===================================================#
	#  Procedure effaçant la partie cxf de la structure	#
	#===================================================#		
	def p_struct_del(self, dict_param):
		"""
			Allow to create the setup directory in the output repertory
			
			PARAMETERS
			==========
				dict_param
				----------
					A dictionnary with all needed parameters	
						
			RETURNS
			=======
				None
		"""
		shutil.rmtree(dict_param["PJ_PATH"], True)
		
		
		
		
#=======================================================================#
#                 			Main de la classe                 			#
#=======================================================================#		
if __name__ == "__main__":
	None
