#!/usr/bin/env python
#-*- coding:utf-8 -*


"""
	Manage the pyxmaker IHM
	
	G{importgraph}
"""


#	Pyxmaker
#	Copyright (C) 2013 GALODE A.
#
#	This file is part of Expymaker.
# 
#	Pyxmaker is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
# 
#	Pyxmaker is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with Pyxmaker.  If not, see <http://www.gnu.org/licenses/>


import pygtk
import gtk
import os
import sys
import uuid
import time
import re




#=======================================================================#
#						Classe gérant l'IHM								#
#=======================================================================#
class IhmPyxmaker():
	"""
		Class which manage the PYGTK IHM
		
		G{classtree}
	"""
	
	
	def __init__(self, listing_menu, listing_lang, dict_config, dict_about, path_base, \
					fct_p_config_save, fct_config_open, fct_lang_change, fct_gener_setup):
		self.listing_menu = listing_menu
		self.listing_lang = listing_lang
		self.dict_config = dict_config
		self.dict_about = dict_about
		self.path_base = path_base
		self.fct_p_config_save = fct_p_config_save
		self.fct_config_open = fct_config_open
		self.fct_lang_change = fct_lang_change
		self.fct_gener_setup = fct_gener_setup
		
		self.scr_idx = 0
		
		self.scr_alim()
		self.scr_exe()
		self.scr_info()
		self.scr_param()
		self.scr_base()
		
		self.p_lang_alim()		
		
		x1, y1 = self.scr_exe_vbox.size_request()
		x2, y2 = self.scr_info_vbox.size_request()
		x3, y3 = self.scr_param_table.size_request()
		x4, y4 = self.scr_base_win.size_request()
		x5, y5 = self.scr_base_win_hbox.size_request()
		self.x = max([x1,x2,x3,x4,x5]) + 50
		self.y = max([y1,y2,y3,y4,y5])
		self.scr_exe_vbox.set_size_request(self.x, self.y)
		self.scr_info_vbox.set_size_request(self.x, self.y)
		self.scr_param_table.set_size_request(self.x, self.y)
		self.scr_base_win.set_size_request(self.x, self.y + y5)
		self.scr_base_win_hbox.set_size_request(self.x, y5)
	
		
		
		
	#===================================================#
	#  		Procedure permettant de lancer l'IHM		#
	#===================================================#	
	def start_ihm(self):
		"""
			Allow to launch the HMI
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		gtk.main()
	
	
	
	
	#===================================================#
	#  			    Fenetre de l'appli					#
	#===================================================#
	def scr_base(self):
		"""
			Main window
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		self.scr_base_win = gtk.Window()
		self.scr_base_win.set_title(self.scr_all_text_title)
		
		self.scr_base_win_tab_main = gtk.Table(rows=2, columns=1, homogeneous=False)
		self.scr_base_win_hbox = gtk.HBox(homogeneous=False, spacing=2)
		
		self.scr_base_win_label_title = gtk.Label()
		self.scr_title(self.scr_info_text_title)
				
		self.scr_base_win_button_previous = gtk.Button()
		self.scr_base_win_button_previous.connect("clicked", self.scr_change_previous)
		self.scr_base_win_button_im_previous = gtk.Image()
		path_previous = os.path.join(self.path_base,"02-IMG/previous.png")
		self.scr_base_win_button_im_previous.set_from_file(path_previous)
		self.scr_base_win_button_previous.add(self.scr_base_win_button_im_previous)
		
		self.scr_base_win_button_next = gtk.Button()
		self.scr_base_win_button_next.connect("clicked", self.scr_change_next)
		self.scr_base_win_button_im_next = gtk.Image()
		path_next = os.path.join(self.path_base,"02-IMG/next.png")
		self.scr_base_win_button_im_next.set_from_file(path_next)
		self.scr_base_win_button_next.add(self.scr_base_win_button_im_next)
		
		self.scr_base_win_hbox.pack_start(self.scr_base_win_button_previous, expand=False, fill=True, padding=2)
		self.scr_base_win_hbox.pack_start(self.scr_base_win_label_title, expand=True, fill=True, padding=2)
		self.scr_base_win_hbox.pack_start(self.scr_base_win_button_next, expand=False, fill=False, padding=2)
		
		self.scr_base_win_tab_main.attach(self.scr_base_win_hbox,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK|gtk.FILL)
		self.scr_base_win_tab_main.attach(self.scr_param_table,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL)
		self.scr_base_win_tab_main.attach(self.scr_info_vbox,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL)
		self.scr_base_win_tab_main.attach(self.scr_exe_vbox,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL)
		self.scr_base_win.add(self.scr_base_win_tab_main)
		self.scr_base_win.connect("destroy", gtk.main_quit)
		
		self.scr_base_win_button_previous.set_sensitive(False)
		self.scr_base_win_button_next.set_sensitive(True)
		
		self.scr_base_win_button_im_previous.show()
		self.scr_base_win_button_im_next.show()
		self.scr_base_win_hbox.show()
		self.scr_base_win_label_title.show()
		self.scr_base_win_button_previous.show()
		self.scr_base_win_button_next.show()
		self.scr_base_win_tab_main.show()
		self.scr_base_win.show()
		
		
		

	#===================================================#
	#  Procedure gerant l'affichage du titre de l'ecran	#
	#===================================================#
	def scr_title(self, texte):
		"""
			Manage the screen title display
			
			PARAMETERS
			==========
				texte
				-----
					The text to display
						
			RETURNS
			=======
				None
		"""
		width = 60
		qty = (width - len(texte)) / 2
		
		texte = texte.ljust(qty + len(texte))
		texte = texte.rjust(width)
		
		title_text = "<b><big><span size=\"xx-large\" foreground=\"white\" background=\"#1E7FCB\">" + \
						texte + "</span></big></b>"
		self.scr_base_win_label_title.set_text(title_text)
		self.scr_base_win_label_title.set_width_chars(width)
		self.scr_base_win_label_title.set_use_markup(True)
		
		
		
		
	#===================================================#
	#  			Procedure alimentant les menus			#
	#===================================================#		
	def scr_alim(self):
		"""
			Allow to supply the menus
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		for i in range(0, len(self.listing_menu)):
			if self.listing_menu[i][0] == "INFO":
				if self.listing_menu[i][1] == "REQUIRED":
					self.scr_info_text_required = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "NAME":
					self.scr_info_text_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "VERSION":
					self.scr_info_text_version = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "AUTHOR":
					self.scr_info_text_author = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "AUTHOR_MAIL":
					self.scr_info_text_author_mail = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "MAINTAINER":
					self.scr_info_text_maintenor = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "MAINTAINER_MAIL":
					self.scr_info_text_maintenor_mail = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "FAST_DESCRIPTION":
					self.scr_info_text_fast_description = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "WEBSITE":
					self.scr_info_text_website = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "TITLE":
					self.scr_info_text_title = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "WINCONS":
					self.scr_info_text_wincons = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "WINCONS_TT":
					self.scr_info_tt_wincons = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "NAME_TT":
					self.scr_info_tt_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "VERSION_TT":
					self.scr_info_tt_version = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "AUTHOR_TT":
					self.scr_info_tt_author = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "AUTHOR_MAIL_TT":
					self.scr_info_tt_author_mail = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "MAINTAINER_TT":
					self.scr_info_tt_maintainer = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "MAINTAINER_MAIL_TT":
					self.scr_info_tt_maintainer_mail = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "FAST_DESCRIPTION_TT":
					self.scr_info_tt_fast_description = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "WEBSITE_TT":
					self.scr_info_tt_website = self.listing_menu[i][2]
						
						
			elif self.listing_menu[i][0] == "EXE":
				if self.listing_menu[i][1] == "TITLE":
					self.scr_exe_text_title = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PJ_DIR":
					self.scr_exe_text_pj_dir = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PY_EXE":
					self.scr_exe_text_py_exe = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP":
					self.scr_exe_text_setup = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_MENU_NAME":
					self.scr_exe_text_setup_menu_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_NAME":
					self.scr_exe_text_setup_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_ICON":
					self.scr_exe_text_setup_icon = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_PASSWD":
					self.scr_exe_text_setup_passwd = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_CREATION":
					self.scr_exe_text_setup_creation = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PJ_DIR_TT":
					self.scr_info_tt_pj_dir = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PY_EXE_TT":
					self.scr_info_tt_py_exe = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_MENU_NAME_TT":
					self.scr_info_tt_setup_menu_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_NAME_TT":
					self.scr_info_tt_setup_name = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_ICON_TT":
					self.scr_info_tt_setup_icon = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_PASSWD_TT":
					self.scr_info_tt_setup_passwd = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SETUP_CREATION_TT":
					self.scr_info_tt_setup_creation = self.listing_menu[i][2]
						
						
			elif self.listing_menu[i][0] == "PARAM":
				if self.listing_menu[i][1] == "LANG":
					self.scr_param_text_lang = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "OPEN":
					self.scr_param_text_open = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SAVE":
					self.scr_param_text_save = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "ABOUT":
					self.scr_param_text_about = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "EXIT":
					self.scr_param_text_exit = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "TITLE":
					self.scr_param_text_title = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "DOC":
					self.scr_param_text_doc = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "LANG_TT":
					self.scr_info_tt_lang = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "OPEN_TT":
					self.scr_info_tt_open = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "SAVE_TT":
					self.scr_info_tt_save = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "ABOUT_TT":
					self.scr_info_tt_about = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "EXIT_TT":
					self.scr_info_tt_exit = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "DOC_TT":
					self.scr_info_tt_doc = self.listing_menu[i][2]
						
						
			elif self.listing_menu[i][0] == "ALL":
				if self.listing_menu[i][1] == "NEXT":
					self.scr_all_text_next = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PREVIOUS":
					self.scr_all_text_previous = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "TITLE":
					self.scr_all_text_title = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "EMPTY_FIELDS":
					self.scr_all_text_fields = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "PATH_ERROR":
					self.scr_all_text_path_error = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "GENERATION_OK":
					self.scr_all_text_gener_ok = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "GENERATION_KO":
					self.scr_all_text_gener_ko = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "GENERATION_OKO":
					self.scr_all_text_gener_oko = self.listing_menu[i][2]
				elif self.listing_menu[i][1] == "WAIT":
					self.scr_all_text_wait = self.listing_menu[i][2]
	
	
	
	
	#===================================================#
	#  			Ecran Information de l'appli			#
	#===================================================#
	def scr_info(self):
		"""
			The information screen
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		self.scr_info_vbox = gtk.VBox()
		
		self.scr_info_frame = gtk.Frame(label = self.scr_info_text_required)
		self.scr_info_tab_main = gtk.Table(rows=5, columns=4, homogeneous=False)
		
		self.scr_info_label_name = gtk.Label(self.scr_info_text_name)
		self.scr_info_label_version = gtk.Label(self.scr_info_text_version)
		self.scr_info_label_author = gtk.Label(self.scr_info_text_author)
		self.scr_info_label_author_mail = gtk.Label(self.scr_info_text_author_mail)
		self.scr_info_label_maintenor = gtk.Label(self.scr_info_text_maintenor)
		self.scr_info_label_maintenor_mail = gtk.Label(self.scr_info_text_maintenor_mail)
		self.scr_info_label_fast_description = gtk.Label(self.scr_info_text_fast_description)
		self.scr_info_label_website = gtk.Label(self.scr_info_text_website)
		
		self.mode_wincons = gtk.CheckButton(self.scr_info_text_wincons)
		self.mode_wincons.set_active(True)
		
		self.scr_info_entry_name = gtk.Entry()
		self.scr_info_entry_version = gtk.Entry()
		self.scr_info_entry_author = gtk.Entry()
		self.scr_info_entry_author_mail = gtk.Entry()
		self.scr_info_entry_maintenor = gtk.Entry()
		self.scr_info_entry_maintenor_mail = gtk.Entry()
		self.scr_info_entry_fast_description = gtk.Entry()
		self.scr_info_entry_website = gtk.Entry()
		
		self.scr_info_entry_tt_name = gtk.Tooltips()
		self.scr_info_entry_tt_version = gtk.Tooltips()
		self.scr_info_entry_tt_author = gtk.Tooltips()
		self.scr_info_entry_tt_author_mail = gtk.Tooltips()
		self.scr_info_entry_tt_maintainer = gtk.Tooltips()
		self.scr_info_entry_tt_maintainer_mail = gtk.Tooltips()
		self.scr_info_entry_tt_fast_description = gtk.Tooltips()
		self.scr_info_entry_tt_website = gtk.Tooltips()
		self.scr_info_checkb_tt_name = gtk.Tooltips()
		
		self.scr_info_entry_tt_name.set_tip(self.scr_info_entry_name, self.scr_info_tt_name, None)
		self.scr_info_entry_tt_version.set_tip(self.scr_info_entry_version, self.scr_info_tt_version, None)
		self.scr_info_entry_tt_author.set_tip(self.scr_info_entry_author, self.scr_info_tt_author, None)
		self.scr_info_entry_tt_author_mail.set_tip(self.scr_info_entry_author_mail, self.scr_info_tt_author_mail, None)
		self.scr_info_entry_tt_maintainer.set_tip(self.scr_info_entry_maintenor, self.scr_info_tt_maintainer, None)
		self.scr_info_entry_tt_maintainer_mail.set_tip(self.scr_info_entry_maintenor_mail, self.scr_info_tt_maintainer_mail, None)
		self.scr_info_entry_tt_fast_description.set_tip(self.scr_info_entry_fast_description, self.scr_info_tt_fast_description, None)
		self.scr_info_entry_tt_website.set_tip(self.scr_info_entry_website, self.scr_info_tt_website, None)
		self.scr_info_checkb_tt_name.set_tip(self.mode_wincons, self.scr_info_tt_wincons, None)
		
		self.scr_info_tab_main.attach(self.scr_info_label_name,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_version,2,3,0,1,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_author,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_author_mail,2,3,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_maintenor,0,1,2,3,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_maintenor_mail,2,3,2,3,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_fast_description,0,1,3,4,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_label_website,0,1,4,5,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		
		self.scr_info_tab_main.attach(self.scr_info_entry_name,1,2,0,1,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_version,3,4,0,1,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_author,1,2,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_author_mail,3,4,1,2,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_maintenor,1,2,2,3,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_maintenor_mail,3,4,2,3,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_fast_description,1,4,3,4,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		self.scr_info_tab_main.attach(self.scr_info_entry_website,1,4,4,5,gtk.EXPAND|gtk.FILL,gtk.EXPAND|gtk.FILL,xpadding=2,ypadding=2)
		
		self.scr_info_frame.add(self.scr_info_tab_main)
		self.scr_info_vbox.pack_start(self.scr_info_frame, expand = False, fill = True, padding = 2)
		self.scr_info_vbox.pack_start(self.mode_wincons, expand = False, fill = True, padding = 2)
				
		self.scr_info_label_name.show()
		self.scr_info_label_version.show()
		self.scr_info_label_author.show()
		self.scr_info_label_author_mail.show()
		self.scr_info_label_maintenor.show()
		self.scr_info_label_maintenor_mail.show()
		self.scr_info_label_fast_description.show()
		self.scr_info_label_website.show()
		
		self.scr_info_entry_name.show()
		self.scr_info_entry_version.show()
		self.scr_info_entry_author.show()
		self.scr_info_entry_author_mail.show()
		self.scr_info_entry_maintenor.show()
		self.scr_info_entry_maintenor_mail.show()
		self.scr_info_entry_fast_description.show()
		self.scr_info_entry_website.show()
		
		self.mode_wincons.show()
		
		self.scr_info_tab_main.show()
		self.scr_info_frame.show()
		
		self.scr_info_vbox.show()	
	
	
	
	
	#===================================================#
	#  			 Ecran executable de l'appli			#
	#===================================================#
	def scr_exe(self):
		"""
			The executable screen
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		self.scr_exe_vbox = gtk.VBox(False, 2)
		self.scr_exe_setup_vbox_left = gtk.VBox(True,4)
		self.scr_exe_setup_vbox_right = gtk.VBox(True,4)
		self.scr_exe_setup_hbox = gtk.HBox(False,4)
		self.scr_exe_pj_hbox = gtk.HBox(False,2)
		self.scr_exe_button_creation_hbox = gtk.HBox(False,2)
		self.scr_exe_button_creation_hbox2 = gtk.HBox(False,2)
		self.scr_exe_hbox_setup_icon = gtk.HBox(False,2)
		
		self.scr_exe_cbox_executable = gtk.combo_box_new_text()
		
		self.scr_exe_frame_pj = gtk.Frame(label = self.scr_exe_text_pj_dir)
		self.scr_exe_frame_executable = gtk.Frame(label = self.scr_exe_text_py_exe)
		self.scr_exe_frame_setup = gtk.Frame(label = self.scr_exe_text_setup)
		
		self.scr_exe_label_button_creation = gtk.Label("<b>" + self.scr_exe_text_setup_creation + "</b>")
		self.scr_exe_label_button_creation.set_use_markup(True)
		self.scr_exe_label_menu_name = gtk.Label(self.scr_exe_text_setup_menu_name)
		self.scr_exe_label_setup_name = gtk.Label(self.scr_exe_text_setup_name)
		self.scr_exe_label_setup_icon = gtk.Label(self.scr_exe_text_setup_icon)
		self.scr_exe_label_setup_passwd = gtk.Label(self.scr_exe_text_setup_passwd)
		
	
		self.scr_exe_entry_pj = gtk.Entry()
		self.scr_exe_entry_setup_name = gtk.Entry()
		self.scr_exe_entry_setup_icon = gtk.Entry()
		self.scr_exe_entry_setup_passwd = gtk.Entry()
		
		self.scr_exe_button_creation = gtk.Button()
		self.scr_exe_button_creation.connect("clicked", self.p_generate_global)
		self.scr_exe_button_im_creation = gtk.Image()
		path_previous = os.path.join(self.path_base,"02-IMG/go_exe.png")
		self.scr_exe_button_im_creation.set_from_file(path_previous)
		self.scr_exe_button_creation_hbox.pack_start(self.scr_exe_button_im_creation, expand=False, fill=False, padding=2)
		self.scr_exe_button_creation_hbox.pack_start(self.scr_exe_label_button_creation, expand=False, fill=False, padding=2)
		self.scr_exe_button_creation.add(self.scr_exe_button_creation_hbox)
		self.scr_exe_button_creation_hbox2.pack_start(self.scr_exe_button_creation, expand=True, fill=False, padding=2)
		
		self.scr_exe_button_pj = gtk.Button()
		self.scr_exe_button_pj.connect("clicked", self.p_select_dir_pj)
		self.scr_exe_button_im_pj = gtk.Image()
		path_pj = os.path.join(self.path_base,"02-IMG/folder.png")
		self.scr_exe_button_im_pj.set_from_file(path_pj)
		self.scr_exe_button_pj.add(self.scr_exe_button_im_pj)
		
		self.scr_exe_button_setup_icon = gtk.Button()
		self.scr_exe_button_setup_icon.connect("clicked", self.p_select_setup_icon)
		self.scr_exe_button_im_setup_icon = gtk.Image()
		path_setp_icon = os.path.join(self.path_base,"02-IMG/load.png")
		self.scr_exe_button_im_setup_icon.set_from_file(path_setp_icon)
		self.scr_exe_button_setup_icon.add(self.scr_exe_button_im_setup_icon)
		
		self.scr_exe_entry_tt_pj = gtk.Tooltips()
		self.scr_exe_entry_tt_setup_name = gtk.Tooltips()
		self.scr_exe_entry_tt_setup_icon = gtk.Tooltips()
		self.scr_exe_entry_tt_setup_passwd = gtk.Tooltips()
		self.scr_exe_cbox_tt_executable = gtk.Tooltips()
		self.scr_exe_button_tt_creation = gtk.Tooltips()
		
		self.scr_exe_entry_tt_pj.set_tip(self.scr_exe_entry_pj, self.scr_info_tt_pj_dir, None)		
		self.scr_exe_entry_tt_setup_name.set_tip(self.scr_exe_entry_setup_name, self.scr_info_tt_setup_name, None)
		self.scr_exe_entry_tt_setup_icon.set_tip(self.scr_exe_entry_setup_icon, self.scr_info_tt_setup_icon, None)
		self.scr_exe_entry_tt_setup_passwd.set_tip(self.scr_exe_entry_setup_passwd, self.scr_info_tt_setup_passwd, None)
		self.scr_exe_cbox_tt_executable.set_tip(self.scr_exe_cbox_executable, self.scr_info_tt_py_exe, None)
		self.scr_exe_button_tt_creation.set_tip(self.scr_exe_button_creation, self.scr_info_tt_setup_creation, None)
		
		self.scr_exe_pj_hbox.pack_start(self.scr_exe_entry_pj)
		self.scr_exe_pj_hbox.pack_start(self.scr_exe_button_pj, expand=False, fill=False)
		self.scr_exe_frame_pj.add(self.scr_exe_pj_hbox)
		
		self.scr_exe_setup_vbox_left.pack_start(self.scr_exe_label_setup_name)
		self.scr_exe_setup_vbox_left.pack_start(self.scr_exe_label_setup_icon)
		self.scr_exe_setup_vbox_left.pack_start(self.scr_exe_label_setup_passwd)
		
		self.scr_exe_hbox_setup_icon.pack_start(self.scr_exe_entry_setup_icon)
		self.scr_exe_hbox_setup_icon.pack_start(self.scr_exe_button_setup_icon, expand=False, fill=False)
		
		self.scr_exe_setup_vbox_right.pack_start(self.scr_exe_entry_setup_name)
		self.scr_exe_setup_vbox_right.pack_start(self.scr_exe_hbox_setup_icon)
		self.scr_exe_setup_vbox_right.pack_start(self.scr_exe_entry_setup_passwd)
		
		self.scr_exe_setup_hbox.pack_start(self.scr_exe_setup_vbox_left, expand=False, fill=False)
		self.scr_exe_setup_hbox.pack_start(self.scr_exe_setup_vbox_right)
		
		self.scr_exe_frame_setup.add(self.scr_exe_setup_hbox)
		self.scr_exe_frame_executable.add(self.scr_exe_cbox_executable)
		
		self.scr_exe_vbox.pack_start(self.scr_exe_frame_pj)
		self.scr_exe_vbox.pack_start(self.scr_exe_frame_executable)
		self.scr_exe_vbox.pack_start(self.scr_exe_frame_setup)
		self.scr_exe_vbox.pack_start(self.scr_exe_button_creation_hbox2, expand=True, fill=True, padding=2)
	
		self.scr_exe_button_pj.show()
		self.scr_exe_button_im_pj.show()
		
		self.scr_exe_button_setup_icon.show()
		self.scr_exe_button_im_setup_icon.show()
		self.scr_exe_hbox_setup_icon.show()
	
		self.scr_exe_label_menu_name.show()
		self.scr_exe_label_setup_name.show()
		self.scr_exe_label_setup_icon.show()
		self.scr_exe_label_setup_passwd.show()
		
		self.scr_exe_entry_pj.show()
		self.scr_exe_entry_setup_name.show()
		self.scr_exe_entry_setup_icon.show()
		self.scr_exe_entry_setup_passwd.show()
		
		self.scr_exe_button_creation.show()
		self.scr_exe_button_im_creation.show()
		self.scr_exe_label_button_creation.show()
		self.scr_exe_button_creation_hbox.show()
		self.scr_exe_button_creation_hbox2.show()
		
		self.scr_exe_frame_pj.show()
		self.scr_exe_frame_executable.show()
		self.scr_exe_frame_setup.show()
		
		self.scr_exe_cbox_executable.show()
		self.scr_exe_pj_hbox.show()
		
		self.scr_exe_setup_vbox_left.show()
		self.scr_exe_setup_vbox_right.show()
		self.scr_exe_setup_hbox.show()
		
		self.scr_exe_vbox.hide()
	



	#===================================================#
	#  		  Ecran de parametrage de l'appli			#
	#===================================================#
	def scr_param(self):
		"""
			The parameters screen
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		self.scr_param_table = gtk.Table(rows=3, columns=2, homogeneous=True)
		
		self.scr_param_frame = gtk.Frame(label = self.scr_param_text_lang)
		self.scr_param_cbox = gtk.combo_box_new_text()
		self.scr_param_cbox.connect("changed", self.p_lang_change)
		
		self.scr_param_button_open = gtk.Button(self.scr_param_text_open)
		self.scr_param_button_open.connect("clicked", self.p_config_open)
		self.scr_param_button_save = gtk.Button(self.scr_param_text_save)
		self.scr_param_button_save.connect("clicked", self.p_config_save)
		self.scr_param_button_about = gtk.Button(self.scr_param_text_about)
		self.scr_param_button_about.connect("clicked", self.win_about)
		self.scr_param_button_doc = gtk.Button(self.scr_param_text_doc)
		self.scr_param_button_doc.connect("clicked", self.p_notice)
		
		self.scr_param_frame.add(self.scr_param_cbox)
		
		self.scr_param_table.attach(self.scr_param_button_open,0,1,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK,xpadding=4,ypadding=4)
		self.scr_param_table.attach(self.scr_param_button_save,0,1,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK,xpadding=4,ypadding=4)
		self.scr_param_table.attach(self.scr_param_button_doc,0,1,2,3,gtk.EXPAND|gtk.FILL,gtk.SHRINK,xpadding=4,ypadding=4)
		self.scr_param_table.attach(self.scr_param_frame,1,2,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK,xpadding=4,ypadding=4)
		self.scr_param_table.attach(self.scr_param_button_about,1,2,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK,xpadding=4,ypadding=4)
		
		self.scr_param_button_open.show()
		self.scr_param_button_save.show()
		self.scr_param_button_about.show()
		self.scr_param_button_doc.show()
		self.scr_param_frame.show()
		self.scr_param_cbox.show()
		
		x, y = self.scr_exe_vbox.size_request()
		self.scr_param_table.set_size_request(x, y)
		
		self.scr_param_table.hide()	
	
	
	
	
	#===================================================#
	#	Procedure lancant l'affichage de la doc PDF		#
	#===================================================#
	def p_notice(self, widget):
		"""
			Launch the PDF documentation
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		#Ne fonctionne que sous windows
		os.startfile(os.path.join(self.path_base,"/00-DOC/Pyxmaker_Notice.pdf")) 




	#===================================================#
	#  	 Procedure gerant le bouton "ecran precedent"	#
	#===================================================#
	def scr_change_previous(self, widget):
		"""
			Manage the "previous screen" button, and screens display
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		if self.scr_idx == 1:
			self.scr_idx = 0
			self.scr_info_vbox.show()
			self.scr_title(self.scr_info_text_title)
			
			self.scr_exe_vbox.hide()
			self.scr_param_table.hide()
			
			self.scr_base_win_button_previous.set_sensitive(False)
			self.scr_base_win_button_next.set_sensitive(True)
			
		elif self.scr_idx == 2:
			self.scr_idx = 1
			self.scr_exe_vbox.show()
			self.scr_title(self.scr_exe_text_title)
			
			self.scr_info_vbox.hide()
			self.scr_param_table.hide()
			
			self.scr_base_win_button_previous.set_sensitive(True)
			self.scr_base_win_button_next.set_sensitive(True)
		
		
		
		
	#===================================================#
	#  	  Procedure gerant le bouton "ecran suivant"	#
	#===================================================#	
	def scr_change_next(self, widget):
		"""
			Manage the "next screen" button, and screens display
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		if self.scr_idx == 0:
			self.scr_idx = 1
			self.scr_exe_vbox.show()
			self.scr_title(self.scr_exe_text_title)
			
			self.scr_exe_entry_setup_name.set_text(self.scr_info_entry_name.get_text() + "_" + self.scr_info_entry_version.get_text())
			
			self.scr_info_vbox.hide()
			self.scr_param_table.hide()
			
			self.scr_base_win_button_next.set_sensitive(True)
			self.scr_base_win_button_previous.set_sensitive(True)
			
		elif self.scr_idx == 1:
			self.scr_idx = 2
			self.scr_param_table.show()
			self.scr_title(self.scr_param_text_title)
			
			self.scr_info_vbox.hide()
			self.scr_exe_vbox.hide()
			
			self.scr_base_win_button_next.set_sensitive(False)
			self.scr_base_win_button_previous.set_sensitive(True)
		
		
		
		
	#===================================================#
	#  				Fenetre a propos de					#
	#===================================================#
	def win_about(self, widget):
		"""
			Show About window dialog
				
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure

			RETURNS
			=======
				None
		"""
		about_win = gtk.AboutDialog()
		about_win.set_name(self.dict_about["SOFT_NAME"])
		about_win.set_version(self.dict_about["VERSION"])
		about_win.set_copyright(self.dict_about["COPYRIGHT"])
		about_win.set_comments(self.dict_about["COMMENTS"])
		about_win.set_license(self.dict_about["LICENCE"])
		about_win.set_website(self.dict_about["WEBSITE"])
		about_win.set_website_label(self.dict_about["WEBSITE_LABEL"])
		about_win.set_authors([self.dict_about["AUTHORS"]])
		about_win.set_documenters([self.dict_about["DOCUMENTERS"]])
		about_win.set_translator_credits(self.dict_about["CREDITS"])
		about_win.run()
		about_win.destroy()
	
	
	
	
	#===================================================#
	#                Fenetre Question                   #
	#===================================================#
	def win_question(self, widget, texte=""):
		"""
			Show a question window to the user with YES/NO buttons
				
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure
					
				texte
				-----
					The text to display in the question window
			
			RETURNS
			=======
				The answer (True or False) of the user
		"""
		quote_win = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_QUESTION, gtk.BUTTONS_YES_NO, texte)
		reponse = quote_win.run()
		quote_win.destroy()
		
		if reponse == gtk.RESPONSE_YES:
			rtr_quote = True
		else:
			rtr_quote = False
		
			
		return rtr_quote
		
		
		
	
	#===================================================#
	#                   Fenetre Info                    #
	#===================================================#
	def win_info(self, widget, texte=""):
		"""
			Create an info window. Wait ack to continue
				
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure
					
				texte
				-----
					The text to display in the question window
			
			RETURNS
			=======
				None
		"""
		info_win = gtk.MessageDialog(self.scr_base_win, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, texte)
		response = info_win.run()
		info_win.show()
		info_win.destroy()

		
	
	
	#===================================================#
	#                  Fenetre Erreur                   #
	#===================================================#	
	def win_error(self, widget, texte=""):
		"""
			Create an error window with texte. Wait ack to continue
				
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure
					
				texte
				-----
					The text to display in the question window
			
			RETURNS
			=======
				None
		"""
		error_win = gtk.MessageDialog(self.scr_base_win, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, texte)
		response = error_win.run()
		error_win.destroy()
	
	
	
	
	#===================================================#
	#        Fenetre de confirmation de creation        #
	#===================================================#	
	def win_confirm(self):
		"""
			Display the different listing to the user for validation 
			before generate the executable
				
			PARAMETERS
			==========
				None
			
			RETURNS
			=======
				None
		"""
		self.win_confirm_win = gtk.Window(type=gtk.WINDOW_TOPLEVEL)
		self.win_confirm_vbox = gtk.VBox()
		
		self.win_confirm_frame_include = gtk.Frame(label = "Include")
		self.win_confirm_frame_exclude = gtk.Frame(label = "Exclude")
		self.win_confirm_frame_package = gtk.Frame(label = "Package")
		self.win_confirm_frame_include_file = gtk.Frame(label = "Include File")
		
		self.win_confirm_entry_include = gtk.Entry()
		self.win_confirm_entry_exclude = gtk.Entry()
		self.win_confirm_entry_package = gtk.Entry()
		self.win_confirm_entry_include_file = gtk.Entry()
		
		self.win_confirm_button = gtk.Button("OK")
		self.win_confirm_button.connect("clicked", self.p_win_confirm_response)
		
		self.win_confirm_entry_include.set_text(self.dico_param["CXF_INCLUDE"])
		self.win_confirm_entry_exclude.set_text(self.dico_param["CXF_EXCLUDE"])
		self.win_confirm_entry_package.set_text(self.dico_param["CXF_PACKAGE"])
		self.win_confirm_entry_include_file.set_text(self.dico_param["CXF_INCLUDE_FILE"])
		
		self.win_confirm_frame_include.add(self.win_confirm_entry_include)
		self.win_confirm_frame_exclude.add(self.win_confirm_entry_exclude)
		self.win_confirm_frame_package.add(self.win_confirm_entry_package)
		self.win_confirm_frame_include_file.add(self.win_confirm_entry_include_file)
		
		self.win_confirm_vbox.pack_start(self.win_confirm_frame_include)
		self.win_confirm_vbox.pack_start(self.win_confirm_frame_exclude)
		self.win_confirm_vbox.pack_start(self.win_confirm_frame_package)
		self.win_confirm_vbox.pack_start(self.win_confirm_frame_include_file)
		self.win_confirm_vbox.pack_start(self.win_confirm_button, expand = False, fill = False, padding = 4)
		
		self.win_confirm_entry_include.show()
		self.win_confirm_entry_exclude.show()
		self.win_confirm_entry_package.show()
		self.win_confirm_entry_include_file.show()
		self.win_confirm_frame_include.show()
		self.win_confirm_frame_exclude.show()
		self.win_confirm_frame_package.show()
		self.win_confirm_frame_include_file.show()
		self.win_confirm_button.show()
		self.win_confirm_vbox.show()
		
		self.win_confirm_win.add(self.win_confirm_vbox)
		self.win_confirm_win.set_transient_for(self.scr_base_win)
		self.win_confirm_win.set_modal(True)
		self.win_confirm_win.set_transient_for(self.scr_base_win)
		
		x, y = self.win_confirm_win.size_request()
		self.win_confirm_win.resize(self.x,y)
		
		self.win_confirm_win.show_now()
		
		
		
	
	#===================================================#
	#  	   	  Procédure validant la generation			#
	#===================================================#
	def p_win_confirm_response(self, widget):
		"""
			Allow to valid the scripts creation
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		self.dico_param["CXF_INCLUDE"] = self.win_confirm_entry_include.get_text()
		self.dico_param["CXF_EXCLUDE"] = self.win_confirm_entry_exclude.get_text()
		self.dico_param["CXF_PACKAGE"] = self.win_confirm_entry_package.get_text()
		self.dico_param["CXF_INCLUDE_FILE"] = self.win_confirm_entry_include_file.get_text()
		
		self.win_confirm_win.destroy()
		
		rtr = self.fct_gener_setup(self.dico_param)
		
		if rtr == 0:
			self.win_info(None, self.scr_all_text_gener_ok)
		elif rtr == 1:
			self.win_info(None, self.scr_all_text_gener_ko)
		else:
			self.win_info(None, self.scr_all_text_gener_oko)
		
		
		
		
	#===================================================#
	#  	Procedure qui alimente la combobox de langues	#
	#===================================================#
	def p_lang_alim(self):
		"""
			Allow to supply the language combobox
			
			PARAMETERS
			==========
				None	
						
			RETURNS
			=======
				None
		"""
		for i in range(len(self.listing_lang)):
			self.scr_param_cbox.append_text(self.listing_lang[i][0])
			
			if (self.listing_lang[i][0] == self.dict_config["LANG"]):
				self.scr_param_iter_cbox_lang = i
		
		self.scr_param_cbox.set_active(self.scr_param_iter_cbox_lang)
		
	
	
	
	#===================================================#
	#  	  Procedure pour changer la langue de l'IHM		#
	#===================================================#
	def p_lang_change(self, widget):
		"""
			Allow to change the language
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		self.fct_lang_change(self.scr_param_cbox.get_active_text())




	#===================================================#
	#  	Procedure pour charger la configuration du PJ	#
	#===================================================#
	def p_config_open(self, widget):
		"""
			Allow to load the project configuration
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		config_open_win = gtk.FileChooserDialog(title=self.scr_exe_text_setup_icon, \
						parent=None, action=gtk.FILE_CHOOSER_ACTION_OPEN, \
						buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK)) #buttons: type puis signal renvoyé, par paire
		
		filtre_config_open = gtk.FileFilter()
		filtre_config_open.set_name("pyxmaker")
		filtre_config_open.add_pattern("*.pxmk")
		
		config_open_win.set_select_multiple(False)
		config_open_win.set_do_overwrite_confirmation(True)		
		config_open_win.add_filter(filtre_config_open)
		
		config_open_win.set_filename("save.pxmk")
		
		retour = config_open_win.run()
		file_chose = config_open_win.get_filename()

		if (retour == gtk.RESPONSE_OK):
			dict_param = self.fct_config_open(file_chose)
			self.scr_info_entry_name.set_text(dict_param["NAME"])
			self.scr_info_entry_version.set_text(dict_param["VERSION"])
			self.scr_info_entry_author.set_text(dict_param["AUTHOR"])
			self.scr_info_entry_author_mail.set_text(dict_param["AUTHOR_MAIL"])
			self.scr_info_entry_maintenor.set_text(dict_param["MAINTAINER"])
			self.scr_info_entry_maintenor_mail.set_text(dict_param["MAINTAINER_MAIL"])
			self.scr_info_entry_fast_description.set_text(dict_param["DESCRIPTION"])
			self.scr_info_entry_website.set_text(dict_param["WEBSITE"])
			self.scr_exe_entry_pj.set_text(dict_param["DIR_PJ"])
			self.scr_exe_entry_setup_name.set_text(dict_param["SETUP_NAME"])
			self.scr_exe_entry_setup_icon.set_text(dict_param["SETUP_ICON"])
			self.scr_exe_entry_setup_passwd.set_text(dict_param["SETUP_PASSWD"])
			
			if dict_param["WINCONS"] == "True":
				self.mode_wincons.set_active(True)
			else:
				self.mode_wincons.set_active(False)
			
			nb = 0
			
			try:
				nb = self.f_load_cbox_exec(None)
			except:
				self.win_error(None, self.scr_all_text_path_error)
				
			self.scr_exe_cbox_executable.set_active(0)
			i = 0
			while self.scr_exe_cbox_executable.get_active_text() <> dict_param["EXECUTABLE"] and i < nb:
				i += 1
				self.scr_exe_cbox_executable.set_active(i)
			
			self.scr_exe_entry_setup_name.set_text(self.scr_info_entry_name.get_text() + "_" + self.scr_info_entry_version.get_text())
			
		config_open_win.destroy()
		
		
		
		
	#===================================================#
	#   Procedure pour sauvegarder la configuration PJ	#
	#===================================================#
	def p_config_save(self, widget):
		"""
			Allow to save the project configuration
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		dict_param, test = self.f_generate_dict_param()	
		
		if test:
			p_config_save = gtk.FileChooserDialog(title=self.scr_exe_text_setup_icon, \
							parent=None, action=gtk.FILE_CHOOSER_ACTION_SAVE, \
							buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK)) #buttons: type puis signal renvoyé, par paire
		
			filtre_p_config_save = gtk.FileFilter()
			filtre_p_config_save.set_name("pyxmaker")
			filtre_p_config_save.add_pattern("*.pxmk")
			
			p_config_save.set_select_multiple(False)
			p_config_save.set_do_overwrite_confirmation(True)		
			p_config_save.add_filter(filtre_p_config_save)
			
			p_config_save.set_filename("save.pxmk")
			
			retour = p_config_save.run()
			file_chose = p_config_save.get_filename()
	
			if (retour == gtk.RESPONSE_OK):
				if file_chose.find(".pxmk") == -1:
					file_chose += ".pxmk"
				self.fct_p_config_save(file_chose, dict_param)
				
			p_config_save.destroy()	
			

		
				
	#===================================================#
	#  	  Procedure pour choisir le dossier du PJ		#
	#===================================================#	
	def p_select_dir_pj(self, widget):
		"""
			Allow to choose the project directory
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		dir_pj = gtk.FileChooserDialog(title=self.scr_exe_text_pj_dir, \
					parent=None, action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER, \
					buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK)) #buttons: type puis signal renvoyé, par paire
		
		dir_pj.set_select_multiple(False)
		dir_pj.set_do_overwrite_confirmation(True)		
		retour = dir_pj.run()
		if retour == gtk.RESPONSE_OK:
			self.scr_exe_entry_pj.set_text(dir_pj.get_filename())
			self.f_load_cbox_exec(None)
		dir_pj.destroy()
		
		
	
	
	#===================================================#
	#  	 Procedure pour choisir l'icone de l'install	#
	#===================================================#
	def p_select_setup_icon(self, widget):
		"""
			Allow to choose an icon for the setup install
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		setup_icon = gtk.FileChooserDialog(title=self.scr_exe_text_setup_icon, \
					parent=None, action=gtk.FILE_CHOOSER_ACTION_OPEN, \
					buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN,gtk.RESPONSE_OK)) #buttons: type puis signal renvoyé, par paire
		
		filtre_setup_icon = gtk.FileFilter()
		filtre_setup_icon.set_name("ico")
		filtre_setup_icon.add_pattern("*.ico")
		
		setup_icon.set_select_multiple(False)
		setup_icon.set_do_overwrite_confirmation(True)		
		setup_icon.add_filter(filtre_setup_icon)
		retour = setup_icon.run()
		file_chose = setup_icon.get_filename()
		if (retour == gtk.RESPONSE_OK) and (file_chose.find(".ico") <> -1):
			self.scr_exe_entry_setup_icon.set_text(setup_icon.get_filename())
		setup_icon.destroy()	
	
	
	
	
	#===================================================#
	#Fonction qui liste les fichiers .py et les packages#
	#===================================================#
	def f_load_py(self, path):
		"""
			Allow to create listing for .py file and package
			
			PARAMETERS
			==========
				path
				----	
					the path to analyze
			RETURNS
			=======
				Two listing that contains the .py files and the directories
		"""
		listing_file = []
		listing_dir = []
		self.listing_ico = []
		for file_rd in os.listdir(path):
			if (not os.path.isdir(os.path.join(path, file_rd))) and (file_rd.find(".py") <> -1) and \
				(file_rd.find(".pyc") == -1) and (file_rd.find(".py~") == -1):
				listing_file.append(file_rd)
			if (not os.path.isdir(os.path.join(path, file_rd))) and (file_rd.find(".ico") <> -1):
				self.listing_ico.append(file_rd)
			
		
			elif os.path.isdir(os.path.join(path, file_rd)):
				listing_dir.append(file_rd)
		
		self.p_cxf_listing(listing_file, listing_dir, path)
		
		return listing_file, listing_dir
				
				
				
				
	#===================================================#
	#  			Fonction qui charge la combobox			#
	#===================================================#			
	def f_load_cbox_exec(self, widget):
		"""
			Allow to supply the .py combobox on executable screen
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				The number of entries in the combobox
		"""
		path = self.scr_exe_entry_pj.get_text()
		listing_py, listing_dir = self.f_load_py(path)
		
		self.scr_exe_cbox_executable.get_model().clear()
		
		for i in listing_py:
			self.scr_exe_cbox_executable.append_text(i)
		
		return len(listing_py)
	
	
	
	
	#===================================================#
	#  		   Fonction qui analyse les fichiers		#
	#===================================================#			
	def f_file_analyze(self, path, listing_file):
		"""
			Allow to analyze .py file
			
			PARAMETERS
			==========
				path
				----
					The package path to analyze
				listing_file
				------------
					Contains the file to analyse
						
			RETURNS
			=======
				None
		"""
		for f in listing_file:
			with open(r"%s"%(os.path.join(path,f),), "r") as file_rd:
				file_line = file_rd.readline()
				while file_line <> "":
					if file_line.split(" ")[0] in ("import","from"):
						if self.listing_include.count(file_line.split()[1]) == 0:
							self.listing_include.append(file_line.split()[1])
						
					file_line = file_rd.readline()
	
	
	
	
	#===================================================#
	#		Fonction qui analyse les packages			#
	#===================================================#			
	def f_package_analyze(self, path):
		"""
			Allow to recursively analyze packages
			
			PARAMETERS
			==========
				path
				----
					The package path to analyze
						
			RETURNS
			=======
				A list of import to add
		"""
		listing_imp = []

		for rd in os.listdir(path + "/"):
			if (not os.path.isdir(os.path.join(path,rd)) and rd[len(rd)-3:] == ".py" and \
				rd <> "__init__.py"):
				self.f_file_analyze(path, [rd])
				
			elif os.path.isdir(os.path.join(path,rd)):
				if "__init__.py" in os.listdir(os.path.join(path, rd )):
					rtr = self.f_package_analyze(os.path.join(path, rd))
				
				if len(rtr) >0:
					listing_imp.extend(rtr)
				
		return listing_imp
	
	
	
	
	#===================================================#
	#  	 Procedure creant les listing pour cx_freeze	#
	#===================================================#
	def p_cxf_listing(self, listing_file, listing_dir, path):
		"""
			Create the different listing for the cx_freeze script
			
			PARAMETERS
			==========
				listing_file
				------------
					The different .py files
				listing_dir
				-----------
					The different directories, and potential package
				path
				----
					The path whele files are located	
			RETURNS
			=======
				None
		"""
		self.listing_include = []
		self.listing_exclude = []
		self.listing_package = []
		self.listing_include_file = []
		
		
		self.f_file_analyze(path, listing_file)
		
				
		for d in listing_dir:
			if d[0] in ("0","1","2","3","4","5","6","7","8","9"):
				self.listing_include_file.append(d)
			
			elif d[0] == "_":
				pass
				
			else:
				for file_rd in os.listdir(os.path.join(path,d)):
					if (not os.path.isdir(os.path.join(os.path.join(path,d),file_rd)) and \
						(file_rd == "__init__.py")):
						self.listing_package.append(d)
						
						for i in range(len(self.listing_include)):
							if self.listing_include[i] == d:
								self.listing_include.remove(d)
	
		for package in self.listing_package:
			listt = self.f_package_analyze(os.path.join(path, package))
			self.listing_include.extend(listt)
			
		
		
	
	#===================================================#
	#  Fonction generant le dictionnaire de parametres	#
	#===================================================#
	def f_generate_dict_param(self):
		"""
			Allow to generate the parameters dctionnary
			
			PARAMETERS
			==========
				None	
			
			RETURNS
			=======
				A dictionnary that contains parameters
				A boolean that indicate the dictionnary creation status
		"""
		modele_version = "^([-\.]?[0-9]{1,}){1,}$"
		modele_mail = "^.{1,}(@).{1,}(\.).{1,}$"
		modele_web = "^(http)s{,1}(://).{1,}(\.).{1,}$"
		
		if (self.scr_info_entry_name.get_text() <> "" and self.scr_info_entry_version.get_text() <> "" and \
			self.scr_info_entry_author.get_text() <> "" and self.scr_info_entry_author_mail.get_text() <> "" and \
			self.scr_info_entry_maintenor.get_text() <> "" and self.scr_info_entry_maintenor_mail.get_text() <> "" and \
			self.scr_info_entry_fast_description.get_text() <> "" and self.scr_info_entry_website.get_text() <> "" and \
			self.scr_exe_entry_pj.get_text() <> "" and self.scr_exe_entry_setup_name.get_text() <> "") and \
			(re.search(modele_mail,self.scr_info_entry_author_mail.get_text()) <> None and \
			 re.search(modele_mail,self.scr_info_entry_maintenor_mail.get_text()) <> None and \
			 re.search(modele_web,self.scr_info_entry_website.get_text()) <> None and \
			 re.search(modele_version, self.scr_info_entry_version.get_text()) <> None):
			
			STRUCT_PATH = self.scr_exe_entry_pj.get_text() + "\\..\\" + self.scr_info_entry_name.get_text().upper() + "_WIN\\"
			SETUP_PATH = STRUCT_PATH + "SETUP\\"
			SETUP_EXE_PATH = SETUP_PATH + "EXE\\"
			PJ_PATH = STRUCT_PATH + self.scr_info_entry_name.get_text().upper() + "\\"
			
			SETUP_EXEC_WITHOUT_PY = self.scr_exe_cbox_executable.get_active_text().split(".")[0] + ".exe"
			
			SCRIPTS_PATH = self.path_base + "\\01-REFS\\"
			
			test_icon = os.path.join(self.scr_exe_entry_pj.get_text(),"icone.ico")
			if os.path.exists(test_icon) and self.listing_include_file.count("icone.ico") == 0:
				self.listing_include_file.append("icone.ico")
			
			LIST_INC = ""
			if len(self.listing_include) > 0:
				LIST_INC = "\"" + self.listing_include[0] + "\""				
				if len(self.listing_include) > 1:
					LIST_INC += ","					
					for i in range(1, len(self.listing_include)):
						LIST_INC += "\"" + self.listing_include[i] + "\""						
						if i < (len(self.listing_include)-1):
							LIST_INC += ","
			
			
			LIST_EXC = ""
			if len(self.listing_exclude) > 0:
				LIST_EXC = "\"" + self.listing_exclude[0] + "\""
				if len(self.listing_exclude) > 1:
					LIST_EXC += ","
					for i in range(1, len(self.listing_exclude)):
						LIST_EXC += "\"" + self.listing_exclude[i] + "\""
						if i < (len(self.listing_exclude)-1):
							LIST_EXC += ","
							
			
			LIST_PAC = ""		
			if len(self.listing_package) > 0:
				LIST_PAC = "\"" + self.listing_package[0] + "\""			
				if len(self.listing_package) > 1:
					LIST_PAC += ","					
					for i in range(1, len(self.listing_package)):
						LIST_PAC += "\"" + self.listing_package[i] + "\""						
						if i < (len(self.listing_package)-1):
							LIST_PAC += ","
			
			
			LIST_INC_F = ""
			if len(self.listing_include_file) > 0:
				LIST_INC_F = "\"" + self.listing_include_file[0] + "\""				
				if len(self.listing_include_file) > 1:
					LIST_INC_F += ","					
					for i in range(1, len(self.listing_include_file)):
						LIST_INC_F += "\"" + self.listing_include_file[i] + "\""						
						if i < (len(self.listing_include_file)-1):
							LIST_INC_F += ","
			
			
			if len(self.listing_ico) > 0:
				ico = self.listing_ico[0]
			else:
				ico = ""
			
			dict_param = {}
			dict_param["NAME"] = self.scr_info_entry_name.get_text()
			dict_param["VERSION"] = self.scr_info_entry_version.get_text()
			dict_param["AUTHOR"] = self.scr_info_entry_author.get_text()
			dict_param["AUTHOR_MAIL"] = self.scr_info_entry_author_mail.get_text()
			dict_param["MAINTAINER"] = self.scr_info_entry_maintenor.get_text()
			dict_param["MAINTAINER_MAIL"] = self.scr_info_entry_maintenor_mail.get_text()
			dict_param["DESCRIPTION"] = self.scr_info_entry_fast_description.get_text()
			dict_param["WEBSITE"] = self.scr_info_entry_website.get_text()
			dict_param["DIR_PJ"] = self.scr_exe_entry_pj.get_text()
			dict_param["ICON_EXEC"] = ico
			dict_param["ICON"] = dict_param["ICON_EXEC"]
			dict_param["SETUP_NAME"] = self.scr_exe_entry_setup_name.get_text()
			dict_param["EXECUTABLE"] = self.scr_exe_cbox_executable.get_active_text()
			dict_param["SETUP_ICON"] = self.scr_exe_entry_setup_icon.get_text()
			dict_param["SETUP_PASSWD"] = self.scr_exe_entry_setup_passwd.get_text()
			dict_param["SETUP_MENU"] = self.scr_info_entry_name.get_text()
			dict_param["SETUP_EXEC_WITHOUT_PY"] = SETUP_EXEC_WITHOUT_PY
			dict_param["SETUP_UID"] = str(uuid.uuid5(uuid.uuid1(uuid.getnode(), int(time.time())),dict_param["NAME"] + "_" + dict_param["VERSION"]))
			dict_param["SETUP_LICENCE"] = PJ_PATH + "_pxmk\Licence.txt"
			dict_param["SETUP_BEFORE"] = PJ_PATH + "_pxmk\Before.txt"
			dict_param["SETUP_AFTER"] = PJ_PATH + "_pxmk\After.txt"
			dict_param["CXF_INCLUDE"] = LIST_INC
			dict_param["CXF_EXCLUDE"] = LIST_EXC
			dict_param["CXF_PACKAGE"] = LIST_PAC
			dict_param["CXF_INCLUDE_FILE"] = LIST_INC_F
			dict_param["CXF_ICON_EXEC"] = PJ_PATH + "icon.ico"
			dict_param["SETUP_OUTPUT_DIR"] = SETUP_PATH
			dict_param["SETUP_PATH"] = SETUP_PATH
			dict_param["STRUCT_PATH"] = STRUCT_PATH
			dict_param["SETUP_EXE_PATH"] = SETUP_EXE_PATH
			dict_param["PJ_PATH"] = PJ_PATH
			dict_param["SCRIPTS_PATH"] = SCRIPTS_PATH
			dict_param["WINCONS"] = str(self.mode_wincons.get_active()) #True si cochée
			
			for key, value in dict_param.items():
				if dict_param[key] is None:
					dict_param[key] = ""
				
			return dict_param, True
		else:
			self.win_error(None, self.scr_all_text_fields)
			return {}, False
		
		
		
		
	#===================================================#
	#  		Lance l'interface de generation				#
	#===================================================#	
	def p_generate_global(self, widget):
		"""
			Launch the creation interface
			
			PARAMETERS
			==========
				widget
				------
					The widget that call the procedure	
						
			RETURNS
			=======
				None
		"""
		self.dico_param, test = self.f_generate_dict_param()
		
		if test:
			self.win_confirm()
	
		
	
	
#=======================================================================#
#                 			Main de la classe                 			#
#=======================================================================#	
if __name__ == "__main__":
	None
