#!/usr/bin/env python
#-*- coding:utf-8 -*


"""
	Allow to get the execution path
	
	G{importgraph}
"""


#	Pyxmaker
#	Copyright (C) 2013 GALODE A.
#
#	This file is part of Expymaker.
# 
#	Pyxmaker is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
# 
#	Pyxmaker is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with Pyxmaker.  If not, see <http://www.gnu.org/licenses/>


import os
import sys




#===================================================#
#       Obtention du bon chemin d'execution         #
#===================================================#
def cxf_get_path():
	"""
		Allow to know the good path under Linux, MAC, and Windows.
		Under Windows, adapt the path betwwen direct execution or 
		trough cx_freeze or PYXMAKER
			
		PARAMETERS
		==========
			None
			
		RETURNS
		=======
			The execution path, adapted to the situation
	"""
	#OS = Linux
	if sys.platform == 'linux2':
		path = os.path.dirname(os.path.abspath(__file__))
		
	#OS = Windows
	elif sys.platform in ("win32", "cygwin"):
		if getattr(sys, 'frozen', False):
			path = os.path.dirname(sys.executable)
		else:
			path = os.path.dirname(os.path.abspath(__file__))
	
	#OS = MAC
	else:
		path = os.path.dirname(os.path.abspath(__file__))
		
	return path
	
	
	
	
#=======================================================================#
#                 				Main                					#
#=======================================================================#	
if __name__ == "__main__":
	print "PATH:", cxf_get_path()
